<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAcknowledgementReactionInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAcknowledgementReactionInfo
 * @subpackage Arrays
 */
class ArrayOfAcknowledgementReactionInfo extends AbstractStructArrayBase
{
    /**
     * The AcknowledgementReactionInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\AcknowledgementReactionInfo[]
     */
    public $AcknowledgementReactionInfo;
    /**
     * Constructor method for ArrayOfAcknowledgementReactionInfo
     * @uses ArrayOfAcknowledgementReactionInfo::setAcknowledgementReactionInfo()
     * @param \patest\StructType\AcknowledgementReactionInfo[] $acknowledgementReactionInfo
     */
    public function __construct(array $acknowledgementReactionInfo = array())
    {
        $this
            ->setAcknowledgementReactionInfo($acknowledgementReactionInfo);
    }
    /**
     * Get AcknowledgementReactionInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\AcknowledgementReactionInfo[]|null
     */
    public function getAcknowledgementReactionInfo()
    {
        return isset($this->AcknowledgementReactionInfo) ? $this->AcknowledgementReactionInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAcknowledgementReactionInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAcknowledgementReactionInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAcknowledgementReactionInfoForArrayConstraintsFromSetAcknowledgementReactionInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAcknowledgementReactionInfoAcknowledgementReactionInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfAcknowledgementReactionInfoAcknowledgementReactionInfoItem instanceof \patest\StructType\AcknowledgementReactionInfo) {
                $invalidValues[] = is_object($arrayOfAcknowledgementReactionInfoAcknowledgementReactionInfoItem) ? get_class($arrayOfAcknowledgementReactionInfoAcknowledgementReactionInfoItem) : sprintf('%s(%s)', gettype($arrayOfAcknowledgementReactionInfoAcknowledgementReactionInfoItem), var_export($arrayOfAcknowledgementReactionInfoAcknowledgementReactionInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AcknowledgementReactionInfo property can only contain items of type \patest\StructType\AcknowledgementReactionInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AcknowledgementReactionInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\AcknowledgementReactionInfo[] $acknowledgementReactionInfo
     * @return \patest\ArrayType\ArrayOfAcknowledgementReactionInfo
     */
    public function setAcknowledgementReactionInfo(array $acknowledgementReactionInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($acknowledgementReactionInfoArrayErrorMessage = self::validateAcknowledgementReactionInfoForArrayConstraintsFromSetAcknowledgementReactionInfo($acknowledgementReactionInfo))) {
            throw new \InvalidArgumentException($acknowledgementReactionInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($acknowledgementReactionInfo) || (is_array($acknowledgementReactionInfo) && empty($acknowledgementReactionInfo))) {
            unset($this->AcknowledgementReactionInfo);
        } else {
            $this->AcknowledgementReactionInfo = $acknowledgementReactionInfo;
        }
        return $this;
    }
    /**
     * Add item to AcknowledgementReactionInfo value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\AcknowledgementReactionInfo $item
     * @return \patest\ArrayType\ArrayOfAcknowledgementReactionInfo
     */
    public function addToAcknowledgementReactionInfo(\patest\StructType\AcknowledgementReactionInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\AcknowledgementReactionInfo) {
            throw new \InvalidArgumentException(sprintf('The AcknowledgementReactionInfo property can only contain items of type \patest\StructType\AcknowledgementReactionInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AcknowledgementReactionInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\AcknowledgementReactionInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\AcknowledgementReactionInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\AcknowledgementReactionInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\AcknowledgementReactionInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\AcknowledgementReactionInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AcknowledgementReactionInfo
     */
    public function getAttributeName()
    {
        return 'AcknowledgementReactionInfo';
    }
}
